package org.fouram.service;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.fouram.core.base.service.BaseService;
import org.fouram.core.plugin.weixin.cp.util.WXCpOaUtil;
import org.fouram.core.util.BeanUtils;
import org.fouram.core.util.DateUtil;
import org.fouram.entity.SapCheck;
import org.fouram.entity.SapUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.google.common.collect.Lists;

import me.chanjar.weixin.cp.bean.WxCpCheckinData;

@Service
public class SapCheckService extends BaseService {

	@Autowired
	private SapUserService userService;

	public Map<String, List<String>> groupList(List<SapUser> list) {
		int listSize = list.size();
		int toIndex = 100;
		Map<String, List<String>> map = new HashMap<>(); // 用map存起来新的分组后数据
		int keyToken = 0;
		for (int i = 0; i < list.size(); i += 100) {
			if (i + 100 > listSize) { // 作用为toIndex最后没有100条数据则剩余几条newList中就装几条
				toIndex = listSize - i;
			}
			List<SapUser> newList = list.subList(i, i + toIndex);
			List<String> userIds = Lists.newArrayList();
			for (SapUser user : newList) {
				userIds.add(user.getUserId());
			}
			map.put("keyName" + keyToken, userIds);
			keyToken++;
		}

		return map;
	}

	public void saveAllUserCheckData() throws Exception {
		List<SapUser> users = userService.selectSuccessList();
		Map<String, List<String>> map = groupList(users);
		int count = 0;
		for (String key : map.keySet()) {
			count = count + 1;
			List<WxCpCheckinData> checkinDatas = WXCpOaUtil.getCheckinData(
					DateUtil.sdfTime.parse("2020-04-01 00:00:00"), DateUtil.sdfTime.parse("2020-04-30 23:59:59"),
					map.get(key));
			System.out.println(checkinDatas.size());
			int subCount = 0;
			for (WxCpCheckinData data : checkinDatas) {
				subCount = subCount + 1;
				SapCheck check = new SapCheck();
				BeanUtils.copyProperties(data, check);
				check.setCheckinDate(new Date(check.getCheckinTime() * 1000));
				check.setCheckinDay(DateUtil.getDay(check.getCheckinDate()));
				if (data.getCheckinType().equals("上班打卡")) {
					saveCheckin(check);
				} else if (data.getCheckinType().equals("下班打卡")) {
					saveCheckoff(check);
				} else if (data.getCheckinType().equals("外出打卡")) {
					saveCheckout(check);
				} else {
					System.out.println(data);
				}
				System.out.println(subCount);
			}
			System.out.println(count);
		}
	}

	public void saveCheckin(SapCheck check) throws Exception {
		save("SapCheckMapper.saveCheckin", check);
	}

	public void saveCheckoff(SapCheck check) throws Exception {
		save("SapCheckMapper.saveCheckoff", check);
	}

	public void saveCheckout(SapCheck check) throws Exception {
		save("SapCheckMapper.saveCheckout", check);
	}
}
